package com.groupingList;

import com.groupingList.EnumProperty.Country;

public class Club {

	private String name;
	private Country country;
	private Integer foundingYear;
	
	private Club(Builder builder) {
		this.name = builder.name;
		this.country = builder.country;
		this.foundingYear = builder.foundingYear;
	}
	
	@Override
	public String toString() {
		return this.name;
	}
	
	public static class Builder {
		// mandatory parameter
		private final String name;

		// optional
		private Country country;
		private Integer foundingYear;

		public Club build() {
			return new Club(this);
		}

		public Builder(String name) {
			this.name = name;
		}

		public Builder setCountry(Country country) {
			this.country = country;
			return this;
		}

		public Builder setFoundingYear(Integer foundingYear) {
			this.foundingYear = foundingYear;
			return this;
		}

	}

	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public Country getCountry() {
		return country;
	}
	public void setCountry(Country country) {
		this.country = country;
	}
	public Integer getFoundingYear() {
		return foundingYear;
	}
	public void setFoundingYear(Integer foundingYear) {
		this.foundingYear = foundingYear;
	}
	
}
