package com.groupingList;

import com.groupingList.EnumProperty.Position;

public class Footballer {

	private String name;
	private Integer age;
	private Position position;
	private Club club;

	private Footballer(Builder builder) {
		this.name = builder.name;
		this.age = builder.age;
		this.position = builder.position;
		this.club = builder.club;
	}
	
	@Override
	public String toString() {
		return this.name;
	}
	
	public static class Builder {
		// mandatory parameter
		private final String name;

		// optional
		private Integer age;
		private Position position;
		private Club club;

		public Footballer build() {
			return new Footballer(this);
		}

		public Builder(String name) {
			this.name = name;
		}

		public Builder setAge(Integer age) {
			this.age = age;
			return this;
		}

		public Builder setPosition(Position position) {
			this.position = position;
			return this;
		}

		public Builder setClub(Club club) {
			this.club = club;
			return this;
		}

	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Integer getAge() {
		return age;
	}

	public void setAge(Integer age) {
		this.age = age;
	}

	public Position getPosition() {
		return position;
	}

	public void setPosition(Position position) {
		this.position = position;
	}

	public Club getClub() {
		return club;
	}

	public void setClub(Club club) {
		this.club = club;
	}

}
