package com.groupingList;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;

/**
 * 
 * @author Selman GUN
 *
 */
public class GroupingList {

	@SuppressWarnings("unchecked")
	public static <E, T> Map<E, List<T>> group(List<T> listToGroup, String groupingCriteria) {

		Map<E, List<T>> grupMap = new HashMap<E, List<T>>();
		for (T item : listToGroup) {
			try {
				E e = (E) BeanUtils.getProperty(item, groupingCriteria);
				if (grupMap.containsKey(e)) {
					grupMap.get(e).add(item);
				} else {
					List<T> list = new ArrayList<T>();
					list.add(item);
					grupMap.put(e, list);
				}
			} catch (IllegalAccessException exception) {
				throw new RuntimeException("Error in grouping !" + exception.getMessage());
			} catch (InvocationTargetException exception) {
				throw new RuntimeException("Error in grouping !" + exception.getMessage());
			} catch (NoSuchMethodException exception) {
				throw new RuntimeException("Error in grouping !" + exception.getMessage());
			}

		}
		return grupMap;

	}

}
