package com.groupingList;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.groupingList.EnumProperty.Country;
import com.groupingList.EnumProperty.Position;

public class GroupingListTest {

	public static void main(String[] args) {
		List<Footballer> footballerList = createFootballerList();
		
		Map<Object, List<Footballer>> positionFootballerGroup = GroupingList.group(footballerList, "position");
		System.out.println("Footballers grouped by position : \n" + positionFootballerGroup);

		Map<Object, List<Footballer>> countryFootballerGroup = GroupingList.group(footballerList, "club.country");
		System.out.println("Footballers grouped by club's country  : \n" + countryFootballerGroup);
		
		//club.country.continent 
	}
	
	private static List<Footballer> createFootballerList(){
		List<Footballer> footballerList = new ArrayList<Footballer>();
		
		
		Club realMadrid = new Club.Builder("Real Madrid").setCountry(Country.SPAIN).build();
		Club barcelona = new Club.Builder("Barcelona").setCountry(Country.SPAIN).build();
		Club besiktas = new Club.Builder("Besiktas").setCountry(Country.TURKEY).build();
		Club liverpool = new Club.Builder("Liverpool").setCountry(Country.ENGLAND).build();
		Club milan = new Club.Builder("Milan").setCountry(Country.ITALY).build();
		Club manu = new Club.Builder("Manchester United").setCountry(Country.ENGLAND).build();
		
		Footballer footballer1 = new Footballer.Builder("Lionel Messi")
		.setAge(24).setPosition(Position.Forward).setClub(barcelona).build();
		
		footballerList.add(footballer1);
		
		Footballer footballer2 = new Footballer.Builder("Christiano Ronaldo")
		.setAge(27).setPosition(Position.Forward).setClub(realMadrid).build();
		
		footballerList.add(footballer2);
		
		Footballer footballer3 = new Footballer.Builder("Ricardo Quaresma")
		.setAge(27).setPosition(Position.Midfielder).setClub(besiktas).build();
		
		footballerList.add(footballer3);
		
		Footballer footballer4 = new Footballer.Builder("Zlatan Ibrahimovic")
		.setAge(30).setPosition(Position.Forward).setClub(milan).build();
		
		footballerList.add(footballer4);
		
		Footballer footballer5 = new Footballer.Builder("Steven Gerard")
		.setAge(30).setPosition(Position.Midfielder).setClub(liverpool).build();
		
		footballerList.add(footballer5);
		
		Footballer footballer6 = new Footballer.Builder("Mesut Ozil")
		.setAge(24).setPosition(Position.Midfielder).setClub(realMadrid).build();
		
		footballerList.add(footballer6);
		
		Footballer footballer7 = new Footballer.Builder("Gerard Pique")
		.setAge(28).setPosition(Position.Defender).setClub(barcelona).build();
		
		footballerList.add(footballer7);
		
		Footballer footballer8 = new Footballer.Builder("Sergio Ramos")
		.setAge(27).setPosition(Position.Defender).setClub(realMadrid).build();

		footballerList.add(footballer8);

		Footballer footballer9 = new Footballer.Builder("Wayne Rooney")
		.setAge(27).setPosition(Position.Forward).setClub(manu).build();
		
		footballerList.add(footballer9);

		Footballer footballer10 = new Footballer.Builder("Rio Ferdinand")
		.setAge(27).setPosition(Position.Defender).setClub(manu).build();
		
		footballerList.add(footballer10);

		return footballerList;
	}

}
